﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Documents.Reports.Report;
using Infragistics.Documents.Reports.Report.Section;
using System.IO;

namespace UltraGirdReportExportWithHeading
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            Report  report = new Report();
            report.Info.Title = "My title";

            report.Preferences.Printing.PaperSize = Infragistics.Documents.Reports.Report.Preferences.Printing.PaperSize.Auto;
            report.Preferences.Printing.PaperOrientation = Infragistics.Documents.Reports.Report.Preferences.Printing.PaperOrientation.Auto;
            report.Preferences.Printing.FitToMargins = true;

            ISection section = report.AddSection();
            section.PageSize = Infragistics.Documents.Reports.Report.PageSizes.A4;
            section.PageMargins.All = 35;

            section.PageNumbering = new Infragistics.Documents.Reports.Report.Section.PageNumbering();
            section.PageNumbering.Style = new Infragistics.Documents.Reports.Report.Text.Style(Infragistics.Documents.Reports.Graphics.Fonts.Arial, Infragistics.Documents.Reports.Graphics.Brushes.Black);
            section.PageNumbering.Continue = true;
            section.PageNumbering.SkipFirst = false;
            section.PageNumbering.Alignment = Infragistics.Documents.Reports.Report.PageNumberAlignment.Right;
            section.PageNumbering.OffsetX = -10;


            // Setup Grid
            Infragistics.Documents.Reports.Report.Text.IText text = section.AddText();
            text.Margins.Bottom = 5;
            text.AddContent("This is my PDF export");

            Infragistics.Documents.Reports.Report.Grid.IGrid grid = section.AddGrid();
            grid.Background = new Infragistics.Documents.Reports.Report.Background(new Infragistics.Documents.Reports.Graphics.Color(240, 240, 220));
            grid.Borders = new Infragistics.Documents.Reports.Report.Borders(Infragistics.Documents.Reports.Graphics.Pens.Black);
            grid.Margins.Top = 5;
            grid.Margins.Bottom = 5;

            Infragistics.Documents.Reports.Report.Grid.IGridColumn column = grid.AddColumn();
            column.Width = new Infragistics.Documents.Reports.Report.RelativeWidth(20);

            column = grid.AddColumn();
            column.Width = new Infragistics.Documents.Reports.Report.FixedWidth(100);

            // ======= Header ===============
            Infragistics.Documents.Reports.Report.Grid.IGridHeader header = grid.Header;
            header.Height = new Infragistics.Documents.Reports.Report.FixedHeight(55);
            header.Repeat = true;

            Infragistics.Documents.Reports.Report.Grid.IGridCell cell = header.AddCell();
            cell.ColSpan = 5;
            cell.Alignment.Vertical = Infragistics.Documents.Reports.Report.Alignment.Middle;
            cell.Borders = new Infragistics.Documents.Reports.Report.Borders(Infragistics.Documents.Reports.Graphics.Pens.Black);
            cell.Background = new Infragistics.Documents.Reports.Report.Background(new Infragistics.Documents.Reports.Graphics.Color(220, 240, 240));

            text = cell.AddText();
            text.Alignment = Infragistics.Documents.Reports.Report.TextAlignment.Center;
            text.AddContent("Grid Header");

            // Add Image
            Infragistics.Documents.Reports.Report.IImage image = cell.AddImage(new Infragistics.Documents.Reports.Graphics.Image(imageList1.Images[0]));
            image.Margins.Top = 0;
            image.Margins.Left = 10;
            image.Margins.Bottom = 0;
            image.Width = new Infragistics.Documents.Reports.Report.RelativeWidth(7);
            image.Height = new Infragistics.Documents.Reports.Report.RelativeHeight(5);
            image.KeepRatio = true;
            // ======= Header ===============


            // ========= Footer ==============
            Infragistics.Documents.Reports.Report.Grid.IGridFooter footer = grid.Footer;
            footer.Height = new Infragistics.Documents.Reports.Report.FixedHeight(35);
            footer.Repeat = true;

            cell = footer.AddCell();
            cell.ColSpan = 5;
            cell.Alignment.Vertical = Infragistics.Documents.Reports.Report.Alignment.Middle;
            cell.Borders = new Infragistics.Documents.Reports.Report.Borders(Infragistics.Documents.Reports.Graphics.Pens.Black);
            cell.Background = new Infragistics.Documents.Reports.Report.Background(new Infragistics.Documents.Reports.Graphics.Color(220, 220, 240));

            text = cell.AddText();
            //text.Style = normalStyle;
            text.Alignment = Infragistics.Documents.Reports.Report.TextAlignment.Center;
            text.AddContent("Grid Footer");
            // ========= Footer ==============


            // ========= Create a rows ===============
            for (int i = 0; i < 100; i++)
            {
                // Column 1
                Infragistics.Documents.Reports.Report.Grid.IGridRow row = grid.AddRow();
                cell = row.AddCell();
                cell.RowSpan = 2;
                cell.Alignment.Vertical = Infragistics.Documents.Reports.Report.Alignment.Middle;
                cell.Borders = new Infragistics.Documents.Reports.Report.Borders(Infragistics.Documents.Reports.Graphics.Pens.Black);
                cell.Paddings.All = 5;
                text = cell.AddText();
                text.AddContent("This is Row " + i.ToString());

                if (i >= 20 && i <= 30) row.KeepWithNext = true;
                 

                // Column 2
                row = grid.AddRow();
                cell = row.AddCell();
                cell.Borders = new Infragistics.Documents.Reports.Report.Borders(Infragistics.Documents.Reports.Graphics.Pens.Black);
                cell.Paddings.All = 5;
                text = cell.AddText();
                text.AddContent("Test data " + i.ToString());
                cell = row.AddCell();
                cell.Alignment.Vertical = Infragistics.Documents.Reports.Report.Alignment.Bottom;
                cell.Borders = new Infragistics.Documents.Reports.Report.Borders(Infragistics.Documents.Reports.Graphics.Pens.Black);
                cell.Paddings.All = 5;

                if (i >= 20 && i <= 30) row.KeepWithNext = true;
            }
            // ========= Create a rows ===============

            System.Random rnd = new System.Random();

            
            report.Publish("..\\..\\Test.pdf", FileFormat.PDF);
            System.Diagnostics.Process.Start("..\\..\\Test.pdf");
        }
    }
}
